FROM ubuntu:22.04 as ruby-image

RUN apt-get update -q \
    && apt-get install -y \
         autoconf \
         g++ \
         gcc \
         git \
         make \
         curl \
         zlib1g-dev \
         libssl-dev \
         locales \
    && apt-get autoremove -yq \
    && apt-get clean -yqq \
    && rm -rf /var/lib/apt/lists/*

RUN echo "en_US.UTF-8 UTF-8" > /etc/locale.gen \
    && locale-gen en_US.UTF-8
ENV LANG en_US.UTF-8
ENV LANGUAGE en_US:en
ENV LC_ALL en_US.UTF-8

# Ruby 2.7.x and 3.0.x can not build against OpenSSL 3.0 which is the
# version with Ubuntu 22.04. This workaround installs OpenSSL 1.1.1q
# from source and builds.
#
# For further details see:
#   - https://bugs.ruby-lang.org/issues/18658
#   - https://github.com/rbenv/ruby-build/pull/1974
RUN curl -fsSL "https://www.openssl.org/source/openssl-1.1.1q.tar.gz" | tar -xzC /tmp \
    && cd /tmp/openssl-1.1.1q \
    && ./config --prefix=/usr/local/openssl --openssldir=/usr/local/openssl shared zlib \
    && make \
    && make install \
    && rm -rf /usr/local/openssl/certs \
    && ln -s /etc/ssl/certs /usr/local/openssl/

ENV RUBY_CONFIGURE_EXTRA_OPTS='--with-openssl-dir=/usr/local/openssl'

<%= Snippets.new(include: %w[versions ruby]).populate %>

FROM ruby-image as builder

# Install required packages
RUN apt-get update -q \
  && DEBIAN_FRONTEND=noninteractive apt-get purge -yq git \
  && DEBIAN_FRONTEND=noninteractive apt-get install -yq --no-install-recommends \
       build-essential \
       autoconf \
       automake \
       autopoint \
       byacc \
       clang \
       libclang-dev \
       libyaml-dev \
       libffi-dev \
       libkrb5-dev \
       libreadline-dev \
       libgdbm-dev \
       libncurses5-dev \
       llvm-dev \
       bzip2 \
       libcurl4-openssl-dev \
       ca-certificates \
       openssh-server \
       libexpat1-dev \
       gettext \
       libz-dev \
       fakeroot \
       ccache \
       distcc \
       unzip \
       tzdata \
       apt-transport-https \
       gnupg \
       pkg-config \
       python3

<%= Snippets.new(fips: fips, exclude: %w[ruby]).populate %>

FROM ubuntu:22.04

LABEL org.opencontainers.image.authors="GitLab Inc. <support@gitlab.com>"

COPY --from=builder / /
